﻿using System;

namespace StartServerWPF.Modules.Main
{
    public class MsEvent
    {
        public int ID { get; set; }
        public DateTime OriginTime { get; set; }
        public double ShowX { get; set; }
        public double ShowY { get; set; }
        public double ShowZ { get; set; }
        public double X { get; set; }
        public double Y { get; set; }
        public double Z { get; set; }
        /// <summary>
        /// 震级
        /// </summary>
        public double ML { get; set; }
        /// <summary>
        /// 定位台站数量
        /// </summary>
        public int NFP { get; set; }
        /// <summary>
        /// 计算震级的台站数量
        /// </summary>
        public int NFM { get; set; }
        /// <summary>
        /// 残差
        /// </summary>
        public double Residual { get; set; }
        /// <summary>
        /// 文件路径
        /// </summary>
        public string FilePath { get; set; }
        public MsEvent()
        {

        }
        public MsEvent(string str)
        {
            string[] evtS = str.Trim(' ').Split(new char[] { ' ' });
            OriginTime = DateTime.Parse(evtS[0]);
            X = double.Parse(evtS[2]);
            Y = double.Parse(evtS[1]);
            Z = double.Parse(evtS[3]);
            int off = 0;
            if (evtS.Length == 7)
            {
                ML = -10;
            }
            else
            {
                ML = double.Parse(evtS[5]);
                off = 2;
            }
            NFP = int.Parse(evtS[4 + off]);
            NFM = int.Parse(evtS[5 + off]);
            Residual = double.Parse(evtS[6 + off]);
        }
        //public DateTime JsonDataFormatConvert(string jdf)
        //{
        //    DateTime cd;
        //    string[] strs = jdf.Trim().Split(new char[] { 'T' });
        //    cd=new DateTime()
        //}
        public override string ToString()
        {
            string MLSTR = "";
            if (ML != -10)
            {
                MLSTR = "ML" + " ";
            }
            string str = OriginTime.ToString("yyyy-MM-dd HH:mm:ss:fff") + " " +
                    Y.ToString() + " " +
                    X.ToString() + " " +
                    Z.ToString() + " " +
                    MLSTR +
                    ML.ToString() + " " + NFP.ToString() + " " + NFM.ToString() + " " +
                    Residual.ToString();
            return str;
        }
    }
}
